// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package issued_certificates

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
)

// New creates a new issued certificates API client.
func New(transport runtime.ClientTransport, formats strfmt.Registry) ClientService {
	return &Client{transport: transport, formats: formats}
}

/*
Client for issued certificates API
*/
type Client struct {
	transport runtime.ClientTransport
	formats   strfmt.Registry
}

// ClientOption is the option for Client methods
type ClientOption func(*runtime.ClientOperation)

// ClientService is the interface for Client methods
type ClientService interface {
	DeleteIssuedCertificate(params *DeleteIssuedCertificateParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*DeleteIssuedCertificateNoContent, error)

	GetIssuedCertificates(params *GetIssuedCertificatesParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*GetIssuedCertificatesOK, error)

	PostIssuedCertificate(params *PostIssuedCertificateParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*PostIssuedCertificateCreated, error)

	UpdateIssuedCertificate(params *UpdateIssuedCertificateParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*UpdateIssuedCertificateOK, error)

	SetTransport(transport runtime.ClientTransport)
}

/*
DeleteIssuedCertificate deletes a issued certificate
*/
func (a *Client) DeleteIssuedCertificate(params *DeleteIssuedCertificateParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*DeleteIssuedCertificateNoContent, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewDeleteIssuedCertificateParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "deleteIssuedCertificate",
		Method:             "DELETE",
		PathPattern:        "/issuedcertificates",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &DeleteIssuedCertificateReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*DeleteIssuedCertificateNoContent)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for deleteIssuedCertificate: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
GetIssuedCertificates gets a list of issued certificates
*/
func (a *Client) GetIssuedCertificates(params *GetIssuedCertificatesParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*GetIssuedCertificatesOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetIssuedCertificatesParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "getIssuedCertificates",
		Method:             "GET",
		PathPattern:        "/issuedcertificates",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &GetIssuedCertificatesReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*GetIssuedCertificatesOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for getIssuedCertificates: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
PostIssuedCertificate creates a new issued certificate
*/
func (a *Client) PostIssuedCertificate(params *PostIssuedCertificateParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*PostIssuedCertificateCreated, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPostIssuedCertificateParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "postIssuedCertificate",
		Method:             "POST",
		PathPattern:        "/issuedcertificates",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &PostIssuedCertificateReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PostIssuedCertificateCreated)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for postIssuedCertificate: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
UpdateIssuedCertificate updates an existing issued certificate
*/
func (a *Client) UpdateIssuedCertificate(params *UpdateIssuedCertificateParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*UpdateIssuedCertificateOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewUpdateIssuedCertificateParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "updateIssuedCertificate",
		Method:             "PUT",
		PathPattern:        "/issuedcertificates",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &UpdateIssuedCertificateReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*UpdateIssuedCertificateOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for updateIssuedCertificate: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

// SetTransport changes the transport on the client
func (a *Client) SetTransport(transport runtime.ClientTransport) {
	a.transport = transport
}
