// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package tickets

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
)

// New creates a new tickets API client.
func New(transport runtime.ClientTransport, formats strfmt.Registry) ClientService {
	return &Client{transport: transport, formats: formats}
}

/*
Client for tickets API
*/
type Client struct {
	transport runtime.ClientTransport
	formats   strfmt.Registry
}

// ClientOption is the option for Client methods
type ClientOption func(*runtime.ClientOperation)

// ClientService is the interface for Client methods
type ClientService interface {
	DeleteTicket(params *DeleteTicketParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*DeleteTicketNoContent, error)

	GetTickets(params *GetTicketsParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*GetTicketsOK, error)

	PostTicket(params *PostTicketParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*PostTicketCreated, error)

	UpdateTicket(params *UpdateTicketParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*UpdateTicketOK, error)

	SetTransport(transport runtime.ClientTransport)
}

/*
DeleteTicket deletes a ticket
*/
func (a *Client) DeleteTicket(params *DeleteTicketParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*DeleteTicketNoContent, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewDeleteTicketParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "deleteTicket",
		Method:             "DELETE",
		PathPattern:        "/tickets",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &DeleteTicketReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*DeleteTicketNoContent)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for deleteTicket: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
GetTickets gets a list of tickets
*/
func (a *Client) GetTickets(params *GetTicketsParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*GetTicketsOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetTicketsParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "getTickets",
		Method:             "GET",
		PathPattern:        "/tickets",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &GetTicketsReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*GetTicketsOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for getTickets: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
PostTicket creates a new ticket
*/
func (a *Client) PostTicket(params *PostTicketParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*PostTicketCreated, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPostTicketParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "postTicket",
		Method:             "POST",
		PathPattern:        "/tickets",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &PostTicketReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PostTicketCreated)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for postTicket: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
UpdateTicket updates an existing ticket
*/
func (a *Client) UpdateTicket(params *UpdateTicketParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*UpdateTicketOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewUpdateTicketParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "updateTicket",
		Method:             "PUT",
		PathPattern:        "/tickets",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &UpdateTicketReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*UpdateTicketOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for updateTicket: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

// SetTransport changes the transport on the client
func (a *Client) SetTransport(transport runtime.ClientTransport) {
	a.transport = transport
}
