// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package topics

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
)

// New creates a new topics API client.
func New(transport runtime.ClientTransport, formats strfmt.Registry) ClientService {
	return &Client{transport: transport, formats: formats}
}

/*
Client for topics API
*/
type Client struct {
	transport runtime.ClientTransport
	formats   strfmt.Registry
}

// ClientOption is the option for Client methods
type ClientOption func(*runtime.ClientOperation)

// ClientService is the interface for Client methods
type ClientService interface {
	GetTopics(params *GetTopicsParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*GetTopicsOK, error)

	PostTopics(params *PostTopicsParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*PostTopicsOK, error)

	SetTransport(transport runtime.ClientTransport)
}

/*
GetTopics gets topic records

Retrieve Topic records from the microservice
*/
func (a *Client) GetTopics(params *GetTopicsParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*GetTopicsOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetTopicsParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "getTopics",
		Method:             "GET",
		PathPattern:        "/topics",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &GetTopicsReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*GetTopicsOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for getTopics: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
PostTopics adds new topics

Add new topics
*/
func (a *Client) PostTopics(params *PostTopicsParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*PostTopicsOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPostTopicsParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "postTopics",
		Method:             "POST",
		PathPattern:        "/topics",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &PostTopicsReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PostTopicsOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for postTopics: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

// SetTransport changes the transport on the client
func (a *Client) SetTransport(transport runtime.ClientTransport) {
	a.transport = transport
}
