// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package tenants

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/vernonkeenan/lib/api/sfgate/sfgate_models"
)

// NewTenantsParams creates a new TenantsParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewTenantsParams() *TenantsParams {
	return &TenantsParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewTenantsParamsWithTimeout creates a new TenantsParams object
// with the ability to set a timeout on a request.
func NewTenantsParamsWithTimeout(timeout time.Duration) *TenantsParams {
	return &TenantsParams{
		timeout: timeout,
	}
}

// NewTenantsParamsWithContext creates a new TenantsParams object
// with the ability to set a context for a request.
func NewTenantsParamsWithContext(ctx context.Context) *TenantsParams {
	return &TenantsParams{
		Context: ctx,
	}
}

// NewTenantsParamsWithHTTPClient creates a new TenantsParams object
// with the ability to set a custom HTTPClient for a request.
func NewTenantsParamsWithHTTPClient(client *http.Client) *TenantsParams {
	return &TenantsParams{
		HTTPClient: client,
	}
}

/*
TenantsParams contains all the parameters to send to the API endpoint

	for the tenants operation.

	Typically these are written to a http.Request.
*/
type TenantsParams struct {

	/* CTenantRequest.

	   An array of Tenant records
	*/
	CTenantRequest *sfgate_models.TenantRequest

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the tenants params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *TenantsParams) WithDefaults() *TenantsParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the tenants params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *TenantsParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the tenants params
func (o *TenantsParams) WithTimeout(timeout time.Duration) *TenantsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the tenants params
func (o *TenantsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the tenants params
func (o *TenantsParams) WithContext(ctx context.Context) *TenantsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the tenants params
func (o *TenantsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the tenants params
func (o *TenantsParams) WithHTTPClient(client *http.Client) *TenantsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the tenants params
func (o *TenantsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithCTenantRequest adds the cTenantRequest to the tenants params
func (o *TenantsParams) WithCTenantRequest(cTenantRequest *sfgate_models.TenantRequest) *TenantsParams {
	o.SetCTenantRequest(cTenantRequest)
	return o
}

// SetCTenantRequest adds the cTenantRequest to the tenants params
func (o *TenantsParams) SetCTenantRequest(cTenantRequest *sfgate_models.TenantRequest) {
	o.CTenantRequest = cTenantRequest
}

// WriteToRequest writes these params to a swagger request
func (o *TenantsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.CTenantRequest != nil {
		if err := r.SetBodyParam(o.CTenantRequest); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
